/*
 * This program is a client that uses our ArrayList class.
 */

#include <iostream>
#include "ArrayList.h"

using namespace std;

void testAdd(ArrayList& list);
void testRemove(ArrayList& list);
void testMisc(ArrayList& list);
void testResize(ArrayList& list);

int main() {

    ArrayList list;
    testAdd(list);
    testRemove(list);
    testResize(list);
    testMisc(list);

    return 0;
}

void testAdd(ArrayList& list) {
    cout << "add:" << endl;
    list.add(42);
    list.add(-5);
    list.add(17);
    list.add(28);
    cout << list.toString() << ", size " << list.size() << endl;
    cout << endl;

    cout << "insert:" << endl;
    list.insert(1, 111);
    cout << list.toString() << ", size " << list.size() << endl;
    list.insert(4, 444);
    cout << list.toString() << ", size " << list.size() << endl;
    list.insert(0, 0);
    cout << list.toString() << ", size " << list.size() << endl;
    list.insert(7, 7777);
    cout << list.toString() << ", size " << list.size() << endl;
    cout << endl;
}

void testRemove(ArrayList& list) {
    cout << "remove:" << endl;
    list.remove(2);
    cout << list.toString() << ", size " << list.size() << endl;
    list.remove(list.size() - 1);
    cout << list.toString() << ", size " << list.size() << endl;
    list.remove(0);
    cout << list.toString() << ", size " << list.size() << endl;
    cout << endl;
}

void testMisc(ArrayList& list) {
    cout << "get:" << endl;
    for (int i = 0; i < list.size(); i++) {
        cout << "index " << i << ": " << list.get(i) << endl;
    }
    cout << endl;

    cout << "set:" << endl;
    list.set(2, 222);
    cout << list.toString() << ", size " << list.size() << endl;
    list.set(0, 12345);
    cout << list.toString() << ", size " << list.size() << endl;
    cout << endl;

    cout << "clear:" << endl;
    list.clear();
    cout << list.toString() << ", size " << list.size() << endl;
    cout << endl;
}

void testResize(ArrayList& list) {
    cout << "resize:" << endl;
    for (int i = 1; i <= 25; i++) {
        list.add(i);
        cout << list.toString() << ", size " << list.size() << endl;
    }
    cout << endl;
}
